
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>AHP-层次分析法(C++源码，附详细注释和样例） / iVAN</title>

    <meta name="description" content="AHP-层次分析法(C++源码，附详细注释和样例） 算法简介 AHP-层次分析法是数学建模中的常用算法,其适用于一批非常广泛的问题,综合来说,它是一个&quot;层次权重决策分析方法&quot;.客观地讲,它适用于一些有限制条件的决策选择问题: 1.    决策有限,且只从有限的候选决策里选择. 2.    决策的影响因素已知,因素的关系(包括隶属关系和优先级关系)已知 3.    因素的关系不论客观与否,要通过合理性校验,即必须是合理的关系才能导出合理的决策. 算法流程 以下例子以旅游选地点为例. 数据统计阶段 步骤1.获取目标层和决策层,对于 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">AHP-层次分析法(C++源码，附详细注释和样例）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>算法简介</h2>
<p>AHP-层次分析法是数学建模中的常用算法，其适用于一批非常广泛的问题，综合来说，它是一个“层次权重决策分析方法”。客观地讲，它适用于一些有限制条件的决策选择问题:</p>
<p>1.    决策有限，且只从有限的候选决策里选择。<br />
2.    决策的影响因素已知，因素的关系（包括隶属关系和优先级关系）已知<br />
3.    因素的关系不论客观与否，要通过合理性校验，即必须是合理的关系才能导出合理的决策。</p>
<h2>算法流程</h2>
<p>以下例子以旅游选地点为例。</p>
<h3>数据统计阶段</h3>
<p>步骤1.获取目标层和决策层，对于旅游问题来说，需要得到候选旅游地点作为决策层，目标层为最后得出的决策。</p>
<p>步骤2.获取中间层信息。除决策层外的每一节点（包括中间层的所有节点和目标层节点），与影响它的节点相连，构造阶梯层次结构，保证为一个有且仅有层与层之间连边的分层图。大概样子如下(from维基）：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MjUwOTU2NTc1MjU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YVhCcGNESXdNRFU9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>    当然，中间层可以不止一层，层与层之间也不一定是全连边的，比如：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNDA5MjUwOTU3MTA0NzM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YVhCcGNESXdNRFU9L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>步骤3.构造成对比较矩阵，对每一个除最底层（决策层，所有的Alternative）的节点，构造该点的成对比较矩阵。该点的成对比较矩阵的含义是所有影响它的因素两两之间的优先级关系。比如上图中Criterion的成对比较矩阵应是一个表示两个Subcriterion优先级关系的2x2矩阵；Criterion2的成对比较矩阵则是4个蓝色的Subcriterion优先级关系的4x4矩阵。</p>
<p>    而优先级关系，一般情况下只用1~9的整数数值来表示。我想一个原因是这个关系通常是主观得到的，过于精细或者过于大的数值都失去了意义；另一个原因在后面会提到，一般情况下设置为1~9已经足够通过合理性（或者叫做一致性检验）了。</p>
<h3>一致性检验</h3>
<p>    一致性检验是整个决策算法可以实施的最为重要的一步，无论你前面的元素关系和成对比较矩阵怎么设置，如果检验结果很差，那么说明优先级关系不太合理（比如A：B=3，B:C=3，A:C=1/9这种不合理的情况）。检验的结果主要依赖于单个矩阵的一致性检验，和综合情况的一致性检验。</p>
<p>    检验的目的主要是判定整个决策过程是否是基于某个近似“所有元素都有一个假想权值”的情况。该问题的本质，也就是求出这组假象的权值，使得我们可以根据这组权值轻松地作出决策。所以一致性检验做的，并不是检查是否有错误的优先级关系，而是检查是否所有的优先级关系满足或近似满足上述“所有元素都有一个假想权值”的情况，越靠近这种情况，检验结果越好。</p>
<h4>一致性检验:单个矩阵的一致性检验</h4>
<p>    单个矩阵的检验的目的，就是为了定量得出该矩阵与“一致阵”的“差距”。</p>
<p>    所谓一致阵A，定义上讲，就是对任意i,j,k，成立Aik*Akj=Aij。通俗地讲，就是存在一组权值，A的每一个位Aij都代表了权值i和权值j的比值。显然，一致阵是最合理的成对比较矩阵。一致阵的例子：</p>
<p>ω:</p>
<table>
<tbody>
<tr>
<td>ω1
</td>
<td>ω2
</td>
<td>ω3
</td>
<td>ω4
</td>
<td>ω5
</td>
</tr>
</tbody>
</table>
<p>A:</p>
<table>
<tbody>
<tr>
<td>1</td>
<td>
ω1/ω2
</td>
<td>ω1/ω3
</td>
<td>ω1/ω4
</td>
<td>ω1/ω5
</td>
</tr>
<tr>
<td>ω2/ω1
</td>
<td>1</td>
<td>ω2/ω3
</td>
<td>ω2/ω4
</td>
<td>ω2/ω5
</td>
</tr>
<tr>
<td>ω3/ω1
</td>
<td>ω3/ω2
</td>
<td>1</td>
<td>ω3/ω4
</td>
<td>ω3/ω5
</td>
</tr>
<tr>
<td>ω4/ω1
</td>
<td>ω4/ω2
</td>
<td>ω4/ω3
</td>
<td>1</td>
<td>ω4/ω5
</td>
</tr>
<tr>
<td>ω5/ω1
</td>
<td>ω5/ω2
</td>
<td>ω5/ω3
</td>
<td>ω5/ω4
</td>
<td>1</td>
</tr>
</tbody>
</table>
<p>    </p>
<p>    我们自己设定的矩阵一般都不是一致阵，怎样衡量它和一致阵的“差距”？</p>
<p>    先考虑这种情况，如果我们已知一致阵，但不知道权值向量，我们怎么通过矩阵求权向量？答案很简单，就是求该一致阵的最大特征根（等于n），然后求出该特征根对应的特征向量作为权值向量（各个行/列向量都对应特征根n），其实任意一行/列都能看出权向量的关系不是么？</p>
<p>    考虑矩阵不是一致阵的情况，因此我们可以类似地先求出矩阵的最大特征根λ，再求出λ对应的归一化权向量ω（以后统称权向量）就可以了,则有Aω=λω，这个称为特征根法。归一化的目的是为了计算每个点的实际选择权值（每层实际和值为1），或称到达“概率”。</p>
<p>    可知λ≥n，在A不是一致阵的情况下，有λ&gt;n,因此我们可以用λ-n的数值来衡量A的与一致阵的“差距”。由此可以定义一致性指标：</p>
<p>    </p>
<p>    接下来的问题是——如何判断这个CI是合格的？</p>
<p>    定义 随机一致性指标RI，代表了在矩阵随机的情况下，矩阵的一致性指标的CI的均值。当然我们不能枚举所有可能的矩阵，所以用随机构造大量成对比较矩阵的方法来近似得到这个均值。</p>
<p>    定义 一致性合格比Δ，只要我们构造的那个成对比较矩阵的CI&lt;RI*Δ,就可以认为我们的矩阵是通过一致性检验的，即它是合理的。一般取Δ=0.1。不太恰当但通俗地说，如果你构造的矩阵A，它与一致性矩阵的“差距”比随机情况下的“差距”乘上Δ还要小，我们认为A是合格的成对比较矩阵。</p>
<h4>一致性检验：综合情况的一致性检验</h4>
<p>    我们已经可以判断每一个成对比较矩阵是否是“合理”的了，那么怎么判断它们综合起来是否合理呢？</p>
<p>    现在所有成对比较矩阵均是合理的，那么对于目标层和第一中间层来说，已经可以求出第一层的到达“概率”，也就是我们求得的目标层权向量，它代表了第一层中间层的每一个元素对于目标层的“重要性”，那么对于第二中间层来说，每个元素的“重要性”是通过目标层的权向量和第一层每个元素的权向量加权相乘得到的。我们要求的就是决策层的到达“概率”</p>
<p>    另外一个考量就是，因为可以通过每层的权向量和层与层之间的连边关系求出最后一层的到达“概率”了，所以最后一层（决策层）的到达“概率”就足以决定目标层的决策了。这也符合我们的预期：从决策层找到权值最大的一个最为目标层的决策。所以检验步骤最后的最后，就是检验决策层的权向量是否“合理”。</p>
<p>    利用已经计算出的一些CI、RI值，定义</p>
<p>    其中这m个CI和RI值分别是最后一层中间层（决策层的上一层）的成对比较矩阵的CI和RI值。只要CR &lt;Δ，就认为通过了综合情况的一致性检验。</p>
<h4>一致性检验：如果通不过一致性检验</h4>
<p>    如果构造的成对比较矩阵通过了一致性检验，那么可以直接用决策层的到达“概率”，取出值最大的决策就可以了。如果通不过一致性检验，则应该考虑重新统计每个成对比较矩阵了。不合理的优先级关系导出的最优决策是不适合作为最优决策的。</p>
<h3>得出决策</h3>
<p>    由于是树形层次结构，我们只要从目标层广度遍历所有点，求出决策层的到达“概率”就可以了。理论上我们应该选择到达“概率”最大的决策作为目标决策。</p>
<hr>
<h2>C++源码</h2>
<p><strong>[cpp]</strong> <a href="http://blog.csdn.net/ipip2005/article/details/39546425#" rel="external nofollow noreferrer">view<br />
 plain</a><a href="http://blog.csdn.net/ipip2005/article/details/39546425#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>#include&lt;iostream&gt;  </li>
<li>#include&lt;cstring&gt;  </li>
<li>#include&lt;cstdio&gt;  </li>
<li>using namespace std;  </li>
<li>struct node{  </li>
<li>    int child[256]; //每个节点的儿子数字，child[0]为儿子个数   </li>
<li>    char name[256]; //节点的名称   </li>
<li>    double** comp;  //该节点概率下的下一层成对比较矩阵   </li>
<li>    double CI;      //CI值   </li>
<li>    double* w;      //最大特征值对应的特征向量   </li>
<li>    double p;       //到达该节点的概率   </li>
<li>    double value;   //只对方案层有效，选取该方案的权重   </li>
<li>}* Node;  </li>
<li>struct level{  </li>
<li>    int num, start_id;//每一层的点数，和起始点的编号   </li>
<li>}* L;  </li>
<li>int n_level, n_node; //总层数，总点数   </li>
<li>/* </li>
<li> * 初始化经验RI数组  </li>
<li> */  </li>
<li>double RI[12]={0,0,0.58,0.9,1.12,1.24,1.32,1.41,1.45,1.49,1.51};  </li>
<li>/* </li>
<li> * 寻找字符c在字符串s中的位置，不存在返回-1 </li>
<li> */   </li>
<li>int pos(char c, char* s){  </li>
<li>    int len = strlen(s);  </li>
<li>    for (int i = 0; i &lt; len; i++){  </li>
<li>        if (s[i] == c) return i;  </li>
<li>    }    </li>
<li>    return -1;  </li>
<li>}  </li>
<li>/* </li>
<li> * 读入一个double或者分数形式的数字  </li>
<li> */  </li>
<li>void myScanf(double* p){  </li>
<li>    char value[256];  </li>
<li>    scanf("%s",value);  </li>
<li>    int place;  </li>
<li>    if ((place = pos('/', value))&gt;0){  </li>
<li>       int f = 0, b = 0;  </li>
<li>       for (int i = 0; i &lt; place; i++){  </li>
<li>           f = f * 10 + value[i] - '0';  </li>
<li>       }  </li>
<li>       for (int i = place + 1; i &lt; strlen(value); i++){  </li>
<li>           b = b * 10 + value[i] - '0';  </li>
<li>       }  </li>
<li>       *p = 1.0 * f / b;  </li>
<li>    } else{  </li>
<li>       *p = 0;  </li>
<li>       for (int i = 0; i &lt; strlen(value); i++){  </li>
<li>           *p = *p * 10 + value[i] - '0';  </li>
<li>       }  </li>
<li>    }  </li>
<li>}  </li>
<li>/* </li>
<li> * 数据输入过程  </li>
<li> */  </li>
<li>void input()  </li>
<li>{  </li>
<li>    printf("输入总层数，包括目标层和方案层:\n");  </li>
<li>    scanf("%d", &amp;n_level);  </li>
<li>    printf("已输入\n");  </li>
<li>       </li>
<li>    L = new level[n_level];  </li>
<li>    n_node = 0;  </li>
<li>    printf("从上往下，输入每层个数:\n");  </li>
<li>    for (int i = 0; i &lt; n_level; i++){  </li>
<li>        scanf("%d",&amp;L[i].num);  </li>
<li>        L[i].start_id = n_node;  </li>
<li>        n_node += L[i].num;         </li>
<li>    }   </li>
<li>    printf("已输入\n");  </li>
<li>   </li>
<li>    Node = new node[n_node];  </li>
<li>    printf("从上往下，输入每层属性名:\n");  </li>
<li>    for (int i = 0; i &lt; n_node; i++){  </li>
<li>        Node[i].child[0] = 0;  </li>
<li>        Node[i].p = 0;  </li>
<li>        Node[i].value = 0;  </li>
<li>        scanf("%s",Node[i].name);  </li>
<li>    }  </li>
<li>    printf("已输入\n");  </li>
<li>    printf("从上往下，输入层与层之间的关系矩阵:\n");  </li>
<li>    for (int i = 0; i &lt; n_level - 1; i++){  </li>
<li>        for (int j = 0; j &lt; L[i].num; j++)  </li>
<li>        for (int k = 0; k &lt; L[i+1].num; k++){  </li>
<li>            int ifConnect;  </li>
<li>            scanf("%d",&amp;ifConnect);  </li>
<li>            if (ifConnect){  </li>
<li>               int cur = L[i].start_id + j;  </li>
<li>               Node[cur].child[0]++;  </li>
<li>               Node[cur].child[Node[cur].child[0]] = L[i+1].start_id + k;  </li>
<li>            }  </li>
<li>        }  </li>
<li>    }  </li>
<li>    printf("已输入\n");  </li>
<li>       </li>
<li>    printf("从上往下，输入成对比较矩阵:\n");  </li>
<li>    for (int i = 0; i &lt; n_level - 1; i++){  </li>
<li>        for (int j = 0; j &lt; L[i].num; j++){  </li>
<li>            int cur = L[i].start_id + j;  </li>
<li>            int size = Node[cur].child[0];  </li>
<li>            Node[cur].comp = new double*[size];  </li>
<li>            for (int k = 0; k &lt; size; k++) Node[cur].comp[k] = new double[size];  </li>
<li>            for (int li = 0; li &lt; size; li++)  </li>
<li>                for (int lj = 0; lj &lt; size; lj++)  </li>
<li>                    myScanf(&amp;Node[cur].comp[li][lj]);  </li>
<li>        }  </li>
<li>    }  </li>
<li>    printf("已输入\n");  </li>
<li>}  </li>
<li>/* </li>
<li> * 程序中止，并输出原因  </li>
<li> */  </li>
<li>void alert(char* p){  </li>
<li>    printf("%s回车退出\n", p);  </li>
<li>    freopen("CON", "r", stdin);  </li>
<li>    system("pause");  </li>
<li>    exit(0);  </li>
<li>}  </li>
<li>/* </li>
<li> * n阶矩阵matrix和w相乘，并归一化w </li>
<li> * retDiv为归一化的倍数，返回归一化后的矩阵  </li>
<li> */  </li>
<li>double* normalize(double** matrix, double* w, int n, double* retDiv){  </li>
<li>    double* ret = new double[n];  </li>
<li>    for (int i = 0; i &lt; n; i++) ret[i] = 0;  </li>
<li>    for (int i = 0; i &lt; n; i++)  </li>
<li>        for (int j = 0; j &lt; n; j++) {  </li>
<li>            ret[i] += matrix[i][j] * w[j];  </li>
<li>        }  </li>
<li>    double sum = 0;  </li>
<li>    for (int i = 0; i &lt; n; i++) sum += ret[i];  </li>
<li>    for (int i = 0; i &lt; n; i++) ret[i]/=sum;  </li>
<li>    *retDiv = sum;  </li>
<li>    return ret;  </li>
<li>}  </li>
<li>/* </li>
<li> * 检查节点编号为id的节点的成对比较矩阵是否通过一致性检验  </li>
<li> */  </li>
<li>bool checkCR(int id){  </li>
<li>    double** matrix = Node[id].comp;  </li>
<li>    int n = Node[id].child[0];  </li>
<li>    double *w = new double[n], *w_new = new double[n];  </li>
<li>    for (int i = 0; i &lt; n; i++) w_new[i] = 1;  </li>
<li>    double eps = 1e-10;  </li>
<li>    double* retDiv = new double;  </li>
<li>    w_new = normalize(matrix, w_new, n, retDiv);  </li>
<li>    while (true){  </li>
<li>          w = w_new;  </li>
<li>          w_new = normalize(matrix, w, n, retDiv);  </li>
<li>          bool flag = true;  </li>
<li>          for (int i = 0; i &lt; n; i++)   </li>
<li>              if (w[i] - w_new[i] &gt; eps || w[i] - w_new[i] &lt; -eps){  </li>
<li>                       flag=false;  </li>
<li>                       break;  </li>
<li>              }  </li>
<li>          if (flag) break;  </li>
<li>    }  </li>
<li>    Node[id].w = w_new;  </li>
<li>    double ans= 0;  </li>
<li>    for (int i = 0; i &lt; n; i++)  </li>
<li>        ans += w_new[i]/w[i];  </li>
<li>    ans = ans * (*retDiv) / n;   </li>
<li>    double CI = (ans - n)/(n-1);  </li>
<li>    Node[id].CI = CI;  </li>
<li>    if (CI &lt; 0.1 * RI[n]) return true;  </li>
<li>    return false;  </li>
<li>}  </li>
<li>/* </li>
<li> * 所有单排序权向量的一致性检验  </li>
<li> */  </li>
<li>void checkSingleMatrix(){  </li>
<li>    for (int i = 0; i &lt; n_level - 1; i++){  </li>
<li>        for (int j = 0; j &lt; L[i].num; j++){  </li>
<li>            int cur = L[i].start_id + j;  </li>
<li>            if (!checkCR(cur)) {  </li>
<li>               printf("第%d层%d号元素&lt;name: %s&gt;的成对比较矩阵无法通过校验,请重新设计",  </li>
<li>                   i, j, Node[cur].name);  </li>
<li>               alert("");  </li>
<li>            }  </li>
<li>               </li>
<li>        }  </li>
<li>    }  </li>
<li>}  </li>
<li>/* </li>
<li> * 总排序权向量的一致性检验  </li>
<li> */  </li>
<li>void checkTotal(){  </li>
<li>    double CR = 0;  </li>
<li>    Node[0].p = 1;  </li>
<li>    /* </li>
<li>     * 计算最后一层中间层的到达概率，即“重要性” </li>
<li>    */  </li>
<li>    for (int i = 0; i &lt; n_level - 2; i++){  </li>
<li>        for (int j = 0; j &lt; L[i].num; j++){  </li>
<li>            int cur = L[i].start_id + j;  </li>
<li>            for (int k = 1; k &lt;= Node[cur].child[0]; k++){  </li>
<li>                int child = Node[cur].child[k];  </li>
<li>                Node[child].p += Node[cur].p * Node[cur].w[k-1];  </li>
<li>            }  </li>
<li>        }  </li>
<li>    }  </li>
<li>    int cL = n_level - 2;  </li>
<li>    double sumaCI = 0, sumaRI = 0;  </li>
<li>    for (int j = 0; j &lt; L[cL].num; j++){  </li>
<li>        int cur = L[cL].start_id + j;  </li>
<li>        sumaCI += Node[cur].p * Node[cur].CI;  </li>
<li>        sumaRI += Node[cur].p * RI[Node[cur].child[0]];  </li>
<li>    }  </li>
<li>    CR = sumaCI / sumaRI;  </li>
<li>    printf("CR值: %.5lf\n",CR);  </li>
<li>    if (CR &gt;= 0.1){  </li>
<li>        alert("无法通过总排序权向量的一致性检验，请重新设计\n");   </li>
<li>    }  </li>
<li>    printf("检验通过\n");   </li>
<li>};  </li>
<li>/* </li>
<li> * 根据经检验后的权重，设计最终方案，比较并选择最优解。  </li>
<li> */  </li>
<li>void design(){  </li>
<li>    int cL = n_level - 2;  </li>
<li>    for (int j = 0; j &lt; L[cL].num; j++){  </li>
<li>        int cur = L[cL].start_id + j;  </li>
<li>        for (int k = 1; k&lt;= Node[cur].child[0]; k++){  </li>
<li>            int child = Node[cur].child[k];  </li>
<li>            Node[child].value += Node[cur].p * Node[cur].w[k-1];  </li>
<li>        }  </li>
<li>    }  </li>
<li>    cL = n_level - 1;  </li>
<li>    double maxValue = -1e10;  </li>
<li>    int maxPlace = -1;  </li>
<li>    for (int j = 0; j &lt; L[cL].num; j++){  </li>
<li>        int cur = L[cL].start_id + j;  </li>
<li>        if (Node[cur].value &gt; maxValue){  </li>
<li>           maxValue = Node[cur].value;  </li>
<li>           maxPlace = cur;  </li>
<li>        }  </li>
<li>        printf("&lt;%s&gt;: %.5lf  ", Node[cur].name, Node[cur].value);  </li>
<li>    }  </li>
<li>    printf("\n\n");  </li>
<li>    printf("最优方案为&lt;%s&gt;, 权重为&lt;%.5lf&gt;\n", Node[maxPlace].name, Node[maxPlace].value);  </li>
<li>};  </li>
<li>/* </li>
<li> * 整个计算过程  </li>
<li> */  </li>
<li>void calc(){  </li>
<li>    printf("单排序权向量一致性检验\n");   </li>
<li>    checkSingleMatrix();  </li>
<li>    printf("检验通过\n");   </li>
<li>    printf("总排序权向量一致性检验\n");   </li>
<li>    checkTotal();  </li>
<li>    printf("计算方案权值\n");  </li>
<li>    design();  </li>
<li>    freopen("CON", "r", stdin);  </li>
<li>    system("pause");  </li>
<li>}  </li>
<li>int main()  </li>
<li>{  </li>
<li>    freopen("level_input.txt","r",stdin);  </li>
<li>    input();  </li>
<li>    calc();  </li>
<li>}  </li>
</ol>
<h2>输入数据文件level_input.txt</h2>
<p><strong>[plain]</strong> <a href="http://blog.csdn.net/ipip2005/article/details/39546425#" rel="external nofollow noreferrer">view<br />
 plain</a><a href="http://blog.csdn.net/ipip2005/article/details/39546425#" rel="external nofollow noreferrer">copy</a></p>
<ol>
<li>3  </li>
<li>   </li>
<li>1 5 3  </li>
<li>   </li>
<li>决策  </li>
<li>景色 费用 居住 饮食 旅途  </li>
<li>苏州 杭州 桂林  </li>
<li>   </li>
<li>1 1 1 1 1  </li>
<li>   </li>
<li>1 1 1  </li>
<li>1 1 1  </li>
<li>1 1 1  </li>
<li>1 1 1  </li>
<li>1 1 1  </li>
<li>   </li>
<li>1 1/2 4 3 3  </li>
<li>2 1 7 5 5  </li>
<li>1/4 1/7 1 1/2 1/3  </li>
<li>1/3 1/5 2 1 1  </li>
<li>1/3 1/5 3 1 1  </li>
<li>   </li>
<li>1 2 5  </li>
<li>1/2 1 2  </li>
<li>1/5 1/2 1  </li>
<li>   </li>
<li>1 1/3 1/8  </li>
<li>3 1 1/3  </li>
<li>8 3 1  </li>
<li>   </li>
<li>1 1 3  </li>
<li>1 1 3  </li>
<li>1/3 1/3 1  </li>
<li>   </li>
<li>1 3 4  </li>
<li>1/3 1 1  </li>
<li>1/4 1 1  </li>
<li>   </li>
<li>1 1 1/4  </li>
<li>1 1 1/4  </li>
<li>4 4 1  </li>
</ol>
<p>本文较长，难免会出现各种各样的错误，欢迎评论批评指正，尊重劳动果实，转载请注明<a href="http://ipipblog.net/article/edit?aid=16" rel="external nofollow noreferrer">ipipblog.net</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-04 15:55:28</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>AHP-层次分析法(C++源码，附详细注释和样例）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEW3Pqp.html" rel="bookmark">层次分析法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				        层次分析法(Analytic Hierarchy Process,简称AHP)是将与决策总是有关的元素分解成目标.准则.方案等层次,在此基础之上进行定性和定量分析的决策方法.该方法是美国运筹学家匹茨堡大学教授萨蒂于20世纪70年代初,在为美国国防部研究&quot;根据各个工业部门对国家福利的贡献大小而进行电力分配&quot;课题时,应用网络系统理论和多目标综合评价方法,提出的一种层次权重决策分析方法.   应用实例编辑 1.建立递阶层次结构: 2.构造两两比较判断矩阵:(正互反矩阵)   			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYj3erp.html" rel="bookmark">Android5&period;1&period;1 - APK签名校验分析和修改源码绕过签名校验</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android5.1.1 - APK签名校验分析和修改源码绕过签名校验 作者:寻禹@阿里聚安全 APK签名校验分析 找到PackageParser类,该类在文件&quot;frameworks/base/core/java/android/content/pm/PackageParser.java&quot;中.PackageParser类的collectCertificates方法会对APK进行签名校验,在该方法会遍历APK中的所有文件,并对每个文件进行校验.下面是该方法的部分源码: APK是一个ZIP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b22ZV4b.html" rel="bookmark">层次分析法计算权重</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				权重在百科中是这样被定义,&quot;权重是一个相对的概念,是针对某一指标而言.某一指标的权重就是指在整体评价中的相对的重要程度.表示在评价这个过程中,它是被评价对象的不同侧面的重要程度的定量来进行分配,对各评价因子在总体评价中的作用进行区别对待&quot;.这句话好像绕口令一样让人难以理解,实际上,在日常生活中充斥着各种各样的决策问题,权重这个概念无意识的被人们广泛使用着. 我们遇到的问题: &quot;哪个问题严重程度相对比较高啊?&quot; &quot;这两个设计方案都挺好的,到底选哪个呢?&qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mye9mkM.html" rel="bookmark">层次分析法-ASP&period;NET数据控件问题 动态表头</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 ASP.NET数据控件问题 动态表头 实现层次分析法指标成对比较的表格用什么形式? 该用什么控件实现动态效果 如 A B C D A B C D 表头是在数据库动态获取.急,谢谢. 解决方案 asp.net你可以用Repeater 解决方案二: 使用Repeater控件可以实现,HeaderTemplate和ItemTemplate中分别加载水平和竖直的数据.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b26Lxrb.html" rel="bookmark">日志分析系统&mdash;&mdash;Hangout源码学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这两天看了下hangout的代码,虽然没有运行体验过,但是也算是学习了一点皮毛. 架构浅谈 Hangout可以说是java版的Logstash,我是没有测试过性能,不过据说是kafka这边性能要高出Logstash5倍.不知道真的假的,不过看代码,确实要比Logstash高效一点. 关于input,filter,output的关系 在Logstash里面,Input,filter,output是三个独立的部分,每个部分通过Buffer存储数据. 但是Hangout没有采用这种思想,每个Input			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDknZWp.html" rel="bookmark">非常实用的js验证框架实现源码 附原理方法&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文为大家分享一个很实用的js验证框架实现源码,供大家参考,具体内容如下 关键方法和原理: function check(thisInput) 方法中的 if (!eval(scriptCode)) { return false; } 调用示例: 复制代码 代码如下: &lt;input type=&quot;text&quot; class=&quot;text_field percentCheck&quot; name=&quot;progress_payment_two&quot; id=&quot			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44PGqz.html" rel="bookmark">jQuery Tab插件 用于在Tab中显示iframe，附源码和详细说明&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者: think8848(公司主页: http://www.cleversoft.com, QQ: 166156888, Blog: http://think8848.cnblogs.com)  转载请保留此信息 CleverTabs是一款jQuery插件,所需jQuery版本:1.6.1,jQuery UI样式版本:1.8.13:其功能为创建jQuery UI风格的Tab用于显示iframe. 本示例中符加了jQuery.contextMenu插件,我修改了其样式,使用了jQuery UI的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPXJ80p.html" rel="bookmark">apache的源码安装详细过程全纪录&lowbar;Linux</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近要开始学习nagios监控方面的知识了,但是nagios与apache结合的比较紧密,所以本篇文章就先把apache的源码安装学习下. 我们现在分以下步骤进行安装apache: 1. 安装编译环境 2. 卸载原有apache 3. 下载解压源码包 4. 安装apache 5. 测试apache 6. 查看apache安装生成的目录 7. 查看apache的配置文件 8. apache加入系统服务 一.安装编译环境 在安装apache之前,我们需要安装编译apache时所需要的相关软件包,如下			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGAw3M.html" rel="bookmark">DirectShow中写push模式的source filter流程 &plus; 源代码&lpar;内附详细注释&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				虽然网上已有很多关于DirectShow写source filter的资料,不过很多刚开始学的朋友总说讲的不是很清楚(可能其中作者省略了许多他认为简 单的过程),读者总希望看到象第一步怎么做,第二步怎么做....这样的demo.其实写你的第一个filter是有一定难度的,只要过了这关以后 就容易多了.由于最近需要自己写一个push推模式的source filter,加上刚激活了Blog,不好意思Blog上没有一篇文章,所以将写这个filter的过程写下来 ,为了照顾刚开始学的朋友,我采用第一步第			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyngZp.html" rel="bookmark" class="title">利用液化滤镜把帅哥头像转为搞笑漫画头像</a>
					<div>
						在网上看多了人物夸张的漫画,手绘又不是很厉害,又想做出效果,实在是纠结...下面的教程就会帮你解决这个问题了,见识一下PS液化功能的强大吧. 原图 最终效果 1.首先打开需要做效果的人物,Ctrl + ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnjLAp.html" rel="bookmark" class="title">Flash高级学习：使用Flex开发个人Blog</a>
					<div>
						高级 全屏观看					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrgOZp.html" rel="bookmark" class="title">Oracle中REMOTE&lowbar;LISTENER对LOAD&lowbar;BALANCE的影响</a>
					<div>
						如果使用DBCA建立RAC数据库,默认情况下会在各个节点上配置REMOTE_LISTENER参数,因此以前测试的LOAD_BALANCE是在REMOTE_LISTENER存在的情况下进行的测试,这里测 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAajmJM.html" rel="bookmark" class="title">英特尔主板挂载LINUX的网卡驱动</a>
					<div>
						一.首先要挂载光驱 #  mount    /media/cdrom   (或mount   /dev/cdrom  /mnt/cdrom) 二.查看(进入)光驱目录 #  cd  /media/cd ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2jGoM.html" rel="bookmark" class="title">php连接access数据库代码</a>
					<div>
						  php教程 连接access数据库教程代码 下面提供三种php连接access数据库方法,一种是利用php的pdo,一种是odbc,com接口来与access数据库连接哦. */ //利用pdo与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLnA3b.html" rel="bookmark" class="title">Fireworks制作铁锈字</a>
					<div>
						现在Photoshop做铁锈字的教程已经很多了, 这里放一个FW做铁锈字的方法, 我这个铁锈字的效果并不是十分到位,但主要说的方法~ 我担心有写朋友没有金属的滤镜所以我也没用,如果金属字的部分直接用滤 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPXjWz.html" rel="bookmark" class="title">Dreamweaver创建预定义的框架集</a>
					<div>
						  在&quot;插入&quot;菜单中选择&quot;HTML&quot;--&quot;框架&quot;,在框架中,我们可以选择你所需要的框架类型,在本例中插入上方及左侧嵌套. 点击某个框架后,可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvK2x9p.html" rel="bookmark" class="title">Ajax 表单验证实现代码</a>
					<div>
						   兼容: opera 9.6 + chrome 2.0 + FF 3 + IE 6  效果:一边输入一边实现验证  image  环境:ruby 1.8.6 + rails 2.1.0 + win ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jre9b.html" rel="bookmark" class="title">PowerPoint竟也可制作3D立体效果</a>
					<div>
						  想制作简单的3D课件,却对专业的3D软件望而生畏?不必苦恼,用PowerPoint也可解燃眉之急.只要巧妙利用它的三维设置功能,同样可以完成3D效果的逼真课件. 制作三维立体图 首先,插入平面自选 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw5ZBp.html" rel="bookmark" class="title">疯狂动物城羚羊舞视频怎么制作</a>
					<div>
						  迪士尼简直丧心病狂!当你在&lt;疯狂动物城&gt;电影中看到豹警官和牛局长玩的跳舞APP后是不是觉得极其有趣呢?!现在,迪士尼已制作出网页版的跳舞视频,名为Dance For Gazelle,翻 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Y2GrM.html" rel="bookmark" class="title">asp中实用分页程序代码</a>
					<div>
						page=request(&quot;page&quot;) if page&lt;&gt;&quot;&quot; then p_absolutepage=cint(page) else p_abs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NkAqz.html" rel="bookmark" class="title">ubuntu和mac OS X下另一种使用QQ的方法</a>
					<div>
						    在ubuntu可以到pidgin官网下载http://www.pidgin.im,然后再安装插件 pidgin-lwqq即可,步骤为: sudo add-apt-repository ppa: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmRJWz.html" rel="bookmark" class="title">Android FrameLayout的android&colon;foreground属性可以设置单击时的前景色</a>
					<div>
						触摸之后,设置前景色,可以告诉用户确实单击了,增加用户体验. &lt;FrameLayout android:foreground=&quot;@drawable/pressed_backgorund ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7q3gp.html" rel="bookmark" class="title">详解 JAVA 适配模式 和 接口适配器</a>
					<div>
						JAVA适配模式 意图将一个类的接口转换成客户希望的另外一个接口.Adapter模式使得原本由于接口不兼容而不能一起工作的那些类可以一起工作.(GoF) 场景 相信很多人都知道什么是显卡,也有很多人知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAlWZM.html" rel="bookmark" class="title">WPF 员工卡条形码</a>
					<div>
						大家都知道条形码(Barcode)是一种可以由机器识别的特殊编码,在生产.生活中也常常会见到并使用它.条形码的类型和种类很多感兴趣的朋友可以详细了解一下.其中Code 39 可以说是一种最为常见并广泛 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRnmRp.html" rel="bookmark" class="title">笔记 - 6、HTML - 框架--frameset</a>
					<div>
						HTML·框架:要在HTML中使用框架,必须先要删除body标签.然后在页面中添加&lt;frameset&gt;&lt;/frameset&gt;标签.      frameset的属性:      ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeQRrb.html" rel="bookmark" class="title">6 cocos2dx粒子效果，类图关系，系统原生粒子和自定义粒子效果，粒子编译器软件，爆炸粒子效果，烟花效果，火焰效果，流星效果，漩涡粒子效果，雪花效果，烟雾效果，太阳效果，下雨效果</a>
					<div>
						﻿﻿ 1 粒子 示例 2 类图关系 3 系统原生粒子 CCParticleSystem 所有粒子系统的父类 CCParticleSystemPoint. CCParticleSystemQuad 点粒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwWo2vz.html" rel="bookmark" class="title">如何 hack Node&period;js 模块？</a>
					<div>
						为何要去 hack? 在业务开发过程中,往往会依赖一些 Node.js 模块,hack 这些 Node.js 模块的主要目的是在不修改工具源码的情况下,篡改一些特定的功能.可能会是出于以下几种情况的考 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgwJDZM.html" rel="bookmark" class="title">&period;net大专在校生要准备升本吗&quest;&quest;</a>
					<div>
						问题描述 在学校学生不知要准备升本吗?有必要吗?这个行业要频繁跳槽才能提薪吗? 解决方案 解决方案二:怎么说呢,如果觉得准备好工作了,那就不用升本了,如果没有就好好读书.我也是专升本的,当时升本的最大 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg158M.html" rel="bookmark" class="title">ios-请问原生IOS程序怎么控制FLASH程序（在IP不确定的情况下）</a>
					<div>
						问题描述 请问原生IOS程序怎么控制FLASH程序(在IP不确定的情况下) 小弟在做一个项目 原生的IOS程序利用局域网控制电脑的FLASH桌面程序 本来是用SOCKET解决,不过这样需要事先绑定IP ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeNrlM.html" rel="bookmark" class="title">雅虎搜索引擎重大升级 竞争对手称无新意</a>
					<div>
						中介交易 SEO诊断淘宝客 站长团购 云主机 技术大厅 新浪科技讯 北京时间10月2日消息,据国外媒体报道,雅虎已经升级了网络搜索引擎,希望让其发挥更大的作用,对用户更具吸引力.在此之前,已经有多家搜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgEPN6z.html" rel="bookmark" class="title">Android实现读取相机（相册）图片并进行剪裁&lowbar;Android</a>
					<div>
						我们先说一下思路,在android系统中就自带了图片剪切的应用,所以,我们只需要将我们获取到的相片传给图片剪切应用,再将剪切好的相片返回到我们自己的界面显示就ok了 在开发一些APP的过程中,我们可能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvY5YNb.html" rel="bookmark" class="title">关于MySQL外键的简单学习教程&lowbar;Mysql</a>
					<div>
						在MySQL中,InnoDB引擎类型的表支持了外键约束. 外键的使用条件: 1.两个表必须是InnoDB表,MyISAM表暂时不支持外键(据说以后的版本有可能支持,但至少目前不支持): 2.外键列必须 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NeG9b.html" rel="bookmark" class="title">jquery&plus;css&plus;ul模拟列表菜单具体实现思路&lowbar;jquery</a>
					<div>
						复制代码 代码如下: &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkEvLp.html" rel="bookmark" class="title">利用location&period;hash实现跨域iframe自适应&lowbar;javascript技巧</a>
					<div>
						页面域关系: 主页面a.html所属域A:www.jb51.net 被iframe的页面b.html所属域B:www.baidu.com,假设地址:http://www.baidu.com/b.htm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0ge0p.html" rel="bookmark" class="title">foobar2000-什么原因才能让音频播放器导致锁屏死机呢</a>
					<div>
						问题描述 什么原因才能让音频播放器导致锁屏死机呢 用foobar2000,某个版本有时就会出现死机的问题 以前我在另一台电脑上用XP还没有问题的,现在的PC装的win7 32位,用这个版本配置就会死机 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZQA4b.html" rel="bookmark" class="title">C&num; 能否导入3D模型？</a>
					<div>
						问题描述 背景描述:有个项目希望将数据导入到BIM中,然后在运维阶段可以在3维的情况下监控各个房间的温湿度等.已经有用C#做了个BA系统.现在希望将BIM和BA系统的数据能交互共享.方案1:在BIM的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXdqL5p.html" rel="bookmark" class="title">新希望拟2亿美元海外收购上游扩张草种业务</a>
					<div>
						刚刚完成重组的新希望在海外市场又有了新动作.日前,新希望集团联合华奥物种欲50.1%控股新西兰一家农业服务公司PGGWrightson,该交易涉及金额约2亿美元,双方已达成要约,正在等待新西兰和中国政 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXvxKz.html" rel="bookmark" class="title">Twitter平台经理：Twitter的注册应用已达10万个</a>
					<div>
						Twitter平台经理瑞恩·沙弗发表演讲(新浪科技摄) 北京时间4月15日凌晨消息,Twitter首届&quot;Chirp开发者大会&quot;展开首日议程,新浪科技前方报道团队,在大会现场进行全程 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWx0wp.html" rel="bookmark" class="title">手游和端游中的社交系统</a>
					<div>
						网游和单机最大的区别在于什么?在于网游拥有单机没有的社交系统. 而社交系统又是什么?就是网游中常见的好友.聊天.组队.PVP.帮派.交易.师徒.结婚.结拜等等. 因为网游就像一个独立的小世界,社交元素 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
